import * as i0 from '@angular/core';
import { Component, EventEmitter, ViewContainerRef, Input, Output, ViewChild, Injectable, NgModule } from '@angular/core';
import { ViewMode } from '@xw-components/model';
import * as i1 from 'ng-zorro-antd/modal';
import * as i2 from 'ng-zorro-antd/message';
import * as i1$1 from '@delon/theme';
import * as i4 from '@delon/form';
import { DelonFormModule } from '@delon/form';
import * as i5 from 'ng-zorro-antd/button';
import { NzButtonModule } from 'ng-zorro-antd/button';
import * as i6 from 'ng-zorro-antd/core/transition-patch';
import * as i7 from 'ng-zorro-antd/core/wave';
import { __decorate } from 'tslib';
import * as i2$1 from '@delon/util';
import { InputBoolean } from '@delon/util';
import * as i3 from 'ng-zorro-antd/dropdown';
import { NzDropDownModule } from 'ng-zorro-antd/dropdown';
import * as i6$1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i7$1 from 'ng-zorro-antd/tree';
import { NzTreeModule } from 'ng-zorro-antd/tree';
import * as i8 from 'ng-zorro-antd/menu';
import { BaseService } from '@xw-components/service';

class CommonTreeNodeEditComponent {
    modal;
    msgSrv;
    httpClient;
    record = {};
    i;
    type;
    businessDesc;
    businessType;
    idEdit;
    schema;
    setSchema() {
        this.schema = {
            properties: {
                pName: {
                    type: 'string',
                    title: '上级节点',
                    ui: {
                        widget: 'text'
                    }
                },
                title: { type: 'string', title: '节点名称' },
                key: { type: 'string', title: '唯一标识', ui: { hidden: !this.idEdit } },
                orderNumber: { type: 'integer', title: '排序', ui: { precision: 0 } }
            },
            required: ['title', 'key']
        };
    }
    ui = {
        '*': {
            spanLabelFixed: 100,
            grid: { span: 24 },
            autocomplete: 'off'
        }
    };
    constructor(modal, msgSrv, httpClient) {
        this.modal = modal;
        this.msgSrv = msgSrv;
        this.httpClient = httpClient;
    }
    ngOnInit() {
        this.i = this.record;
        this.setSchema();
        ViewMode.edit === this.type ? (this.schema.properties['key'].readOnly = true) : '';
    }
    save(value) {
        let apiObserver;
        if (this.type === ViewMode.add) {
            apiObserver = this.httpClient.post('/api/v1.0/commonTree/add', {
                id: value.key,
                pid: this.record.pKey,
                name: value.title,
                orderNumber: value.orderNumber,
                businessType: this.businessType,
                businessDesc: this.businessDesc
            });
        }
        else {
            apiObserver = this.httpClient.post('/api/v1.0/commonTree/update', {
                id: value.key,
                name: value.title,
                orderNumber: value.orderNumber
            });
        }
        apiObserver.subscribe(res => {
            if (res.code === 0) {
                this.msgSrv.success(res.msg);
                this.modal.close(true);
            }
            else {
                this.msgSrv.error(res.msg);
            }
        });
    }
    close() {
        this.modal.destroy();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CommonTreeNodeEditComponent, deps: [{ token: i1.NzModalRef }, { token: i2.NzMessageService }, { token: i1$1._HttpClient }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: CommonTreeNodeEditComponent, selector: "xw-common-tree-node-edit", ngImport: i0, template: "<div class=\"modal-header\">\r\n  <div class=\"modal-title\">{{ type === 1 ? '\u65B0\u5EFA\u4E0B\u7EA7\u8282\u70B9' : '\u4FEE\u6539' + record.name }}</div>\r\n</div>\r\n<sf #sf mode=\"edit\" [schema]=\"schema\" [ui]=\"ui\" [formData]=\"i\" button=\"none\">\r\n  <div class=\"modal-footer\">\r\n    <button nz-button type=\"button\" (click)=\"close()\">\u5173\u95ED</button>\r\n    <button nz-button type=\"submit\" nzType=\"primary\" (click)=\"save(sf.value)\" [disabled]=\"!sf.valid\">\u4FDD\u5B58</button>\r\n  </div>\r\n</sf>\r\n", dependencies: [{ kind: "component", type: i4.SFComponent, selector: "sf, [sf]", inputs: ["layout", "schema", "ui", "formData", "button", "liveValidate", "autocomplete", "firstVisual", "onlyVisual", "compact", "mode", "loading", "disabled", "noColon", "cleanValue", "delay"], outputs: ["formValueChange", "formChange", "formSubmit", "formReset", "formError"], exportAs: ["sf"] }, { kind: "component", type: i5.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }, { kind: "directive", type: i6.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { kind: "directive", type: i7.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CommonTreeNodeEditComponent, decorators: [{
            type: Component,
            args: [{ selector: 'xw-common-tree-node-edit', template: "<div class=\"modal-header\">\r\n  <div class=\"modal-title\">{{ type === 1 ? '\u65B0\u5EFA\u4E0B\u7EA7\u8282\u70B9' : '\u4FEE\u6539' + record.name }}</div>\r\n</div>\r\n<sf #sf mode=\"edit\" [schema]=\"schema\" [ui]=\"ui\" [formData]=\"i\" button=\"none\">\r\n  <div class=\"modal-footer\">\r\n    <button nz-button type=\"button\" (click)=\"close()\">\u5173\u95ED</button>\r\n    <button nz-button type=\"submit\" nzType=\"primary\" (click)=\"save(sf.value)\" [disabled]=\"!sf.valid\">\u4FDD\u5B58</button>\r\n  </div>\r\n</sf>\r\n" }]
        }], ctorParameters: function () { return [{ type: i1.NzModalRef }, { type: i2.NzMessageService }, { type: i1$1._HttpClient }]; } });

class CommonTreeComponent {
    httpClient;
    arrayService;
    contextMenuService;
    modal;
    msg;
    modalService;
    // ----------------------输入属性----------------------
    businessType;
    leftClick = new EventEmitter();
    treeClick = new EventEmitter();
    idEdit = false;
    tree;
    vc;
    /**
     *  @description
     *  drawMenu 自定义右键菜单
     *  drawMenuType: 'default'(默认追加) | 'replace'(替换),
     *  customDrawMenuOption :ngemplate
     *
     * **/
    drawMenuType = 'default';
    customDrawMenuOption;
    ngOnInit() {
        this.getTreeNodes();
    }
    constructor(httpClient, arrayService, contextMenuService, modal, msg, modalService) {
        this.httpClient = httpClient;
        this.arrayService = arrayService;
        this.contextMenuService = contextMenuService;
        this.modal = modal;
        this.msg = msg;
        this.modalService = modalService;
    }
    treeData = {
        showFlag: false,
        title: '',
        data: [],
        expandedKeys: [],
        leftClickNode: undefined,
        rightClickNode: undefined
    };
    getTreeNodes() {
        this.httpClient
            .post('/api/v1.0/commonTree/data', {
            businessType: this.businessType
        })
            .subscribe((res) => {
            this.treeData.data = res.data.treeData;
            this.treeData.title = res.data.businessDesc;
            //重新赋值之前都展开
            this.treeData.expandedKeys = this.tree.getExpandedNodeList().map(node => node.key);
            this.arrayService.visitTree(this.treeData.data, (item, parent, deep) => {
                item.isLeaf = !item.children?.length;
                item.expanded = deep < 4;
            });
        });
    }
    onLeftClick(event) {
        this.onTreeClick(event);
        this.leftClick.emit(event.selectedKeys);
    }
    onRightClick(event, menu) {
        this.treeData.rightClickNode = event.node;
        this.onTreeClick(event);
        this.contextMenuService.create(event.event, menu);
    }
    onTreeClick(e) {
        this.treeClick.emit(e);
    }
    onAddChildNode() {
        this.modal
            .create(CommonTreeNodeEditComponent, {
            record: {
                pKey: this.treeData.rightClickNode?.key,
                pName: this.treeData.rightClickNode?.title
            },
            type: ViewMode.add,
            businessType: this.businessType,
            businessDesc: this.treeData.title,
            idEdit: this.idEdit
        })
            .subscribe(res => {
            this.getTreeNodes();
        });
    }
    onUpdateNode() {
        this.modal
            .create(CommonTreeNodeEditComponent, {
            record: {
                pName: this.treeData.rightClickNode?.parentNode?.title,
                key: this.treeData.rightClickNode?.key,
                title: this.treeData.rightClickNode?.title,
                orderNumber: this.treeData.rightClickNode?.origin.orderNumber
            },
            type: ViewMode.edit,
            idEdit: this.idEdit
        })
            .subscribe(res => {
            this.getTreeNodes();
        });
    }
    onRemoveNode() {
        if (!this.treeData.rightClickNode?.parentNode) {
            this.msg.error('根节点无法删除！');
            return;
        }
        this.modalService.confirm({
            nzTitle: '确认删除吗！',
            nzOnOk: () => {
                this.httpClient
                    .post('/api/v1.0/commonTree/remove', {
                    id: this.treeData.rightClickNode?.key
                })
                    .subscribe(res => {
                    res.code == 0 ? this.getTreeNodes() : '';
                    this.msg.create(res.code == 0 ? 'success' : 'error', res.msg);
                });
            }
        });
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CommonTreeComponent, deps: [{ token: i1$1._HttpClient }, { token: i2$1.ArrayService }, { token: i3.NzContextMenuService }, { token: i1$1.ModalHelper }, { token: i2.NzMessageService }, { token: i1.NzModalService }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: CommonTreeComponent, selector: "xw-common-tree", inputs: { businessType: "businessType", idEdit: "idEdit", drawMenuType: "drawMenuType", customDrawMenuOption: "customDrawMenuOption" }, outputs: { leftClick: "leftClick", treeClick: "treeClick" }, viewQueries: [{ propertyName: "tree", first: true, predicate: ["tree"], descendants: true, static: true }, { propertyName: "vc", first: true, predicate: ["vc"], descendants: true, read: ViewContainerRef }], exportAs: ["XwCommonTree"], ngImport: i0, template: "<div style=\"height: 100%; border: 1px solid #d9d9d9\">\r\n  <div style=\"padding: 10px 15px; background-color: #f5f5f5\">{{ treeData.title }}</div>\r\n  <div style=\"padding-top: 15px; overflow-y: auto; border-top: 1px #d9d9d9 solid\">\r\n    <nz-tree\r\n      #tree\r\n      [nzData]=\"treeData.data\"\r\n      (nzClick)=\"onLeftClick($event)\"\r\n      (nzContextMenu)=\"onRightClick($event, menu)\"\r\n      [nzExpandedKeys]=\"treeData.expandedKeys\"\r\n    ></nz-tree>\r\n  </div>\r\n</div>\r\n<nz-dropdown-menu #menu>\r\n  <ul nz-menu>\r\n    <div *ngIf=\"drawMenuType !== 'replace'\">\r\n      <li nz-menu-item (click)=\"onAddChildNode()\">\u65B0\u5EFA\u4E0B\u7EA7</li>\r\n      <li nz-menu-item (click)=\"onUpdateNode()\">\u4FEE\u6539</li>\r\n      <ng-container #vc [ngTemplateOutlet]=\"customDrawMenuOption\"></ng-container>\r\n      <li nz-menu-item *ngIf=\"treeData.rightClickNode?.parentNode\" (click)=\"onRemoveNode()\" class=\"text-error\">\u5220\u9664</li>\r\n    </div>\r\n    <div *ngIf=\"drawMenuType == 'replace'\">\r\n      <ng-container #vc [ngTemplateOutlet]=\"customDrawMenuOption\"></ng-container>\r\n    </div>\r\n  </ul>\r\n</nz-dropdown-menu>\r\n", dependencies: [{ kind: "directive", type: i6$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i6$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i7$1.NzTreeComponent, selector: "nz-tree", inputs: ["nzShowIcon", "nzHideUnMatched", "nzBlockNode", "nzExpandAll", "nzSelectMode", "nzCheckStrictly", "nzShowExpand", "nzShowLine", "nzCheckable", "nzAsyncData", "nzDraggable", "nzMultiple", "nzExpandedIcon", "nzVirtualItemSize", "nzVirtualMaxBufferPx", "nzVirtualMinBufferPx", "nzVirtualHeight", "nzTreeTemplate", "nzBeforeDrop", "nzData", "nzExpandedKeys", "nzSelectedKeys", "nzCheckedKeys", "nzSearchValue", "nzSearchFunc"], outputs: ["nzExpandedKeysChange", "nzSelectedKeysChange", "nzCheckedKeysChange", "nzSearchValueChange", "nzClick", "nzDblClick", "nzContextMenu", "nzCheckBoxChange", "nzExpandChange", "nzOnDragStart", "nzOnDragEnter", "nzOnDragOver", "nzOnDragLeave", "nzOnDrop", "nzOnDragEnd"], exportAs: ["nzTree"] }, { kind: "directive", type: i8.NzMenuDirective, selector: "[nz-menu]", inputs: ["nzInlineIndent", "nzTheme", "nzMode", "nzInlineCollapsed", "nzSelectable"], outputs: ["nzClick"], exportAs: ["nzMenu"] }, { kind: "component", type: i8.NzMenuItemComponent, selector: "[nz-menu-item]", inputs: ["nzPaddingLeft", "nzDisabled", "nzSelected", "nzDanger", "nzMatchRouterExact", "nzMatchRouter"], exportAs: ["nzMenuItem"] }, { kind: "component", type: i3.NzDropdownMenuComponent, selector: "nz-dropdown-menu", exportAs: ["nzDropdownMenu"] }, { kind: "directive", type: i6.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }] });
}
__decorate([
    InputBoolean()
], CommonTreeComponent.prototype, "idEdit", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CommonTreeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'xw-common-tree', exportAs: 'XwCommonTree', template: "<div style=\"height: 100%; border: 1px solid #d9d9d9\">\r\n  <div style=\"padding: 10px 15px; background-color: #f5f5f5\">{{ treeData.title }}</div>\r\n  <div style=\"padding-top: 15px; overflow-y: auto; border-top: 1px #d9d9d9 solid\">\r\n    <nz-tree\r\n      #tree\r\n      [nzData]=\"treeData.data\"\r\n      (nzClick)=\"onLeftClick($event)\"\r\n      (nzContextMenu)=\"onRightClick($event, menu)\"\r\n      [nzExpandedKeys]=\"treeData.expandedKeys\"\r\n    ></nz-tree>\r\n  </div>\r\n</div>\r\n<nz-dropdown-menu #menu>\r\n  <ul nz-menu>\r\n    <div *ngIf=\"drawMenuType !== 'replace'\">\r\n      <li nz-menu-item (click)=\"onAddChildNode()\">\u65B0\u5EFA\u4E0B\u7EA7</li>\r\n      <li nz-menu-item (click)=\"onUpdateNode()\">\u4FEE\u6539</li>\r\n      <ng-container #vc [ngTemplateOutlet]=\"customDrawMenuOption\"></ng-container>\r\n      <li nz-menu-item *ngIf=\"treeData.rightClickNode?.parentNode\" (click)=\"onRemoveNode()\" class=\"text-error\">\u5220\u9664</li>\r\n    </div>\r\n    <div *ngIf=\"drawMenuType == 'replace'\">\r\n      <ng-container #vc [ngTemplateOutlet]=\"customDrawMenuOption\"></ng-container>\r\n    </div>\r\n  </ul>\r\n</nz-dropdown-menu>\r\n" }]
        }], ctorParameters: function () { return [{ type: i1$1._HttpClient }, { type: i2$1.ArrayService }, { type: i3.NzContextMenuService }, { type: i1$1.ModalHelper }, { type: i2.NzMessageService }, { type: i1.NzModalService }]; }, propDecorators: { businessType: [{
                type: Input
            }], leftClick: [{
                type: Output
            }], treeClick: [{
                type: Output
            }], idEdit: [{
                type: Input
            }], tree: [{
                type: ViewChild,
                args: ['tree', { static: true }]
            }], vc: [{
                type: ViewChild,
                args: ['vc', { read: ViewContainerRef }]
            }], drawMenuType: [{
                type: Input
            }], customDrawMenuOption: [{
                type: Input
            }] } });

class CommonTreeService extends BaseService {
    constructor(http) {
        super(http);
    }
    getTreeDataForSelect(businessType) {
        return this.http.post(`${BaseService.BASE_URL}commonTree/data`, { businessType });
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CommonTreeService, deps: [{ token: i1$1._HttpClient }], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CommonTreeService, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CommonTreeService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1$1._HttpClient }]; } });

const COMPONENTS = [CommonTreeComponent];
const NO_ROUTE_COMPONENT = [CommonTreeNodeEditComponent];
class CommonTreeModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CommonTreeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: CommonTreeModule, declarations: [CommonTreeComponent, CommonTreeNodeEditComponent], imports: [CommonModule, DelonFormModule, NzTreeModule, NzDropDownModule, NzButtonModule], exports: [CommonTreeComponent] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CommonTreeModule, imports: [CommonModule, DelonFormModule, NzTreeModule, NzDropDownModule, NzButtonModule] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CommonTreeModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, DelonFormModule, NzTreeModule, NzDropDownModule, NzButtonModule],
                    declarations: [...COMPONENTS, ...NO_ROUTE_COMPONENT],
                    exports: [...COMPONENTS]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { CommonTreeComponent, CommonTreeModule, CommonTreeNodeEditComponent, CommonTreeService };
//# sourceMappingURL=common-tree.mjs.map
